<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/paper-input/paper-input.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/command-input/command-input.html">
<link rel="import" href="/extern/bower_components/juicy-jsoneditor/src/juicy-jsoneditor.html">
<link rel="import" href="/extern/bower_components/iron-a11y-keys/iron-a11y-keys.html">
<link rel="import" href="/ts/common-elements/ts-ajax/ts-ajax.html">
<link rel="import" href="/ts/common-elements/auto-update/auto-update.html">

<!--
`ts-command` is the element that renders a command panel.

Example:

    <ts-command name="My Command Panel" parameters="..."></ts-command>

Parameters should look something like this:

    [
      {
        "variable": "my_variable_name",
        "type": "string",
        "default": "my default value"
      },
      {
        "variable": "my_second_variable_name",
        "type": "int",
        "default": 42
      }
    ]

This element uses the [`command-input` element](/ts/common-elements/command-input/index.html)

-->
<dom-module id="ts-command">
    <template>
        <style include="iron-flex-layout-attributes"></style>
        <style include="reset-css"></style>
        <iron-a11y-keys target="[[_target]]"
                        keys="enter"
                        on-keys-pressed="_onEnter"></iron-a11y-keys>
        <link rel="import" type="css" href="css/ts-command-min.css?__inline=true">
        <ts-ajax id="ajax" callback="ts-command-submit" handle-as="text" on-response="_handleResponse"></ts-ajax>
        <h2>{{name}}</h2>
        <div horizontal layout wrap>
            <template is="dom-repeat" items="{{parameters}}">
                <command-input id="[[_toId(item.variable)]]"
                               name="[[item.variable]]"
                               value="[[item.default]]"
                               type="[[item.type]]"></command-input>
            </template>
        </div>
        <paper-button raised on-click="_submit">Submit</paper-button>
        <h2>Result</h2>
        <auto-update id="autoupdate" callback="command-refresh" on-data-changed="_handleAutoupdate" no-refresh handle-as="text"></auto-update>
        <div id="result">
          <p>Awaiting the click of the 'submit' button...</p>
        </div>
    </template>
    <script src="javascript/ts-command-min.js?__inline=true"></script>
</dom-module>
